;==========================================================================
; Directory module (2011-11-29)
; (C) 2011 Num Kadoma
;==========================================================================
; tab=8, col=80, asm=xasm32(ver1.33)

		include	hmf.inc
;--------------------------------------------------------------------------
; e`
;--------------------------------------------------------------------------
; RAM
key:		equ	1		; L[ԍ
dev:		equ	2		; DSDRV:̃hCuio
num_ir:		equ	2		; RAM̈mۗ


; Tu[`ԍ
get_crfile:	equ	0		; J[\ʒũt@C擾
call_dsdrv:	equ	1		; DSDRIVEďoTu
chk_name:	equ	2		; DSDRIVEďoTu


;--------------------------------------------------------------------------
; W[wb_
;--------------------------------------------------------------------------
version:	equ	$0001
		db	'DIR     '	; W[
		dw	end_ptr + MDLHEADER_SIZE
					; W[TCY
		dw	version		; o[W
		db	0		; 
		db	0		; tO
		dw	cust_area	; JX^}CYf[^
		dw	subrtn_tbl	; Tu[`AhXe[u


;--------------------------------------------------------------------------
; W[{
;--------------------------------------------------------------------------
		org	0
		scope_on
		pre_on

		iralloc	num_ir		; RAM ̈m
		mv	(bp+key), a	; L[ԍۑ

	; JghCufBNgɑΉĂ邩`FbN
		;(DSDRIVEɔC)
		;sys	!DIR_GETDEVNUM	; JghCũfoCXio擾
		;mv	il, $18		; fBNg擾(gR}h18h)
		;sys	!CALL_IOCS
		;jrc	exit		; G[?

	; DSDRIVẼT[`
		mvix	dsdrv		; hCu擪AhX擾
		mv	il, $00		; hCũT[`(00h)
		sys	!CALL_IOCS	; "DSDRV:"T[`
		jrc	exit		; G[?

		mv	(bp+dev),(!cl)	; DSDRIVẼfoCXioۑ

	; L[ԍɉĕ
		mv	a, (bp+key)	; L[ԍ
		test	a, $ff
		jrz	cd_current	; 0(J[\ʒũfBNgֈړ)

		dec	a
		jrz	cd_parent	; 1(efBNgֈړ)

		dec	a
		jrz	cd_root		; 2([gfBNgֈړ)

		dec	a
		jrz	mkdir		; 3(fBNg쐬)

		dec	a
		jrz	rmdir		; 4(fBNg폜)

		jr	exit		; ȊO(ʏ킱ɂ͗Ȃ)


;--------------------------------------------------------------------------
; fBNg̈ړ
;--------------------------------------------------------------------------
	; J[\ʒũfBNgֈړ
cd_current:
		subcall	get_crfile	; J[\ʒũt@C擾
		jrnc	exit		; fBNgłȂ?

		mv	a, 6
		add	x, a		; hCu΂ăt@C擪
		jr	cd

	; efBNgֈړ
cd_parent:
		mvix	parent		; x=efBNg擪AhX
		jr	cd

	; [gfBNgֈړ
cd_root:
		mvix	root		; x=[gfBNg擪AhX

	; fBNgړC
cd:
		mv	il, $41		; fBNg̈ړ(41h)
		subcall	call_dsdrv
		jrc	exit		; G[?

		mv	il, 0		; fBNg擪̃t@C
		sys	FR_SETCRFILE	; Jgt@CύX

		jr	update


;--------------------------------------------------------------------------
; fBNg̍쐬
;--------------------------------------------------------------------------
mkdir:
		mvix	msg_mkdir	; x=bZ[W擪
		mv	a, !PMI_STR|!PMF_NONE
		mv	y, $fffff
		sys	!FR_PUTMSG	; bZ[W\&fBNg
		jrc	exit		; LZꂽ?

		subcall	chk_name
		jrc	invalid_name	; sȃfBNg?

		pushu	x		; fBNg擪AhXޔ
		mvix	mksector
		mv	a, [x]		; mۂfBNgZN^
		sub	a, '0'		; lɕϊ
		popu	x		; fBNg擪AhXA
		mv	il, $42		; fBNg̍쐬(42h)
		subcall	call_dsdrv
		jrnc	update		; G[łȂ?

		jr	error		; G[


;--------------------------------------------------------------------------
; fBNg̍폜
;--------------------------------------------------------------------------
rmdir:
		subcall	get_crfile	; J[\ʒũt@C擾
		jrnc	exit		; fBNgłȂ?

		mv	a, 6
		add	x, a		; hCu΂ăt@C擪

		subcall	chk_name
		jrc	exit		; sȃfBNg?

		pushu	x
		mvix	msg_rmdir
		mv	a, !PMI_YN|!PMF_MARK
		sys	!FR_PUTMSG	; bZ[W\
		popu	x
		cmp	a, !YN_YES
		jrnz	exit		; YI΂Ȃ?

		mv	il, $43		; fBNg̈ړ(43h)
		subcall	call_dsdrv
		jrnc	update		; G[łȂ

;		jr	error		; G[


;--------------------------------------------------------------------------
; G[
;--------------------------------------------------------------------------
error:
		mv	a, (!rom_errno)
		cmp	a, 74
		jrz	already_exist	; directory already exists

		cmp	a, 76
		jrz	not_empty	; directory not empty

		cmp	a, 77
		jrz	puterror	; disk full

		cmp	a, 86
		jrz	puterror	; file already open

		jr	others

already_exist:
		mv	il, msg_err74
		jr	errormsg

not_empty:
		mv	il, msg_err76
		jr	errormsg

invalid_name:
		mv	il, msg_invalid
errormsg:
		pushu	i
		sys	!FR_FILESCLS	; t@C񕔕̉ʂNA
		popu	i
		sys	!GET_MCDADR	; x=G[bZ[W擪(i狁߂)
		mvw	(!bx), $0119	; G[bZ[W\ʒu()
		mv	a, [x-1]	; G[bZ[W̒+1
		dec	a		; +1̕
		mv	y, 0
		add	y, a		; 
		shr	a		; /2
		sub	(!bl), a	; ɕ\悤XW𒲐
		mv	il, $42		; Cӂ̈ʒuւno(42h)
		sys	!CALL_LCD	; G[bZ[W\

		mv	a, 0		; 4sڒ
		sys	!LB_HITANYKEY	; Hit any key! \
		jr	exit

others:
		mv	a, !ERR_ERROR
puterror:
		sys	!FR_PUTERROR	; G[\
		jr	exit


;--------------------------------------------------------------------------
; I
;--------------------------------------------------------------------------
update:
		or	(!hmf_flag), !HF_INIT
exit:
		irfree			; RAM ̈
		retf


;--------------------------------------------------------------------------
; J[\ʒũt@C擾Tu
;--------------------------------------------------------------------------
;Eentry
;@Ȃ
;Ereturn
;@x  = t@C擪AhX+6(hCuXLbv)
;@cf = 0 : fBNgł͂Ȃ
;@     1 : fBNg
sub_get_crfile:
	; WX^ޔ
		pushu	a
		pushu	i

	; t@C擾
		mvix	crfile		; x=t@C擾AhX
		sys	!FR_GETCRFILE	; Jgt@C̎擾
		mv	a, [x+19]	; t@C(bit5=fBNg)
		swap	a
		shr	a		; cf=fBNg

	; WX^A
		popu	i
		popu	a

		retf


;--------------------------------------------------------------------------
; DSDRIVEďoTu
;--------------------------------------------------------------------------
;Eentry
;@il = t@NVio(41h`43h)
;Ereturn
;@cf = 0 : G[Ȃ
;@     1 : G[
sub_call_dsdrv:
		sys	!DIR_GETDEVNUM	; JghCũfoCXio擾
		mvw	(!dx), (!cx)	; Ώۂ̃foCXioAhCuio
		mv	(!cl), (bp+dev)	; DSDRIVẼfoCXio
		sys	!CALL_IOCS

		retf


;--------------------------------------------------------------------------
; fBNg`FbNTu
;--------------------------------------------------------------------------
;Eentry
;@x = fBNg擪AhX
;Ereturn
;@cf = 0 : G[Ȃ
;@     1 : G[(t@C'.'Ŏn܂Ă)
sub_chk_name:	local
	; WX^ޔ
		pushu	a

	; `FbN
		mv	a, [x]
		cmp	a, '.'
		jrz	err		; '.'Ŏn܂t@C?

		rc			; G[Ȃ
		jr	e
err:
		sc			; G[
e:
	; WX^A
		popu	a

		retf
		endl


;--------------------------------------------------------------------------
; Tu[`AhXe[u
;--------------------------------------------------------------------------
subrtn_tbl:
		dw	sub_get_crfile
		dw	sub_call_dsdrv
		dw	sub_chk_name


;--------------------------------------------------------------------------
; JX^}CYf[^
;--------------------------------------------------------------------------
cust_area:
		csdata	 1, mksector,    '1'
		csdata	 2, msg_mkdir,   'mKdir:'
		csdata	 3, msg_mkdir2,  ' '
		csdata	 4, msg_mkdir3,  'DIR NAME  INPUT ø޻'
		csdata	 5, msg_mkdir4,  ' '
		csdata	 6, msg_rmdir,   'rmdir:'
		csdata	 7, msg_rmdir2,  ' '
		csdata	 8, msg_rmdir3,  '  ޮϽ'
		csdata	 9, msg_rmdir4,  ' '
		csdata	10, msg_err74,   'directory already exists'
		csdata	11, msg_err76,   'directory not empty'
		csdata	12, msg_invalid, 'invalid directory name'
		csdata	13, dsdrv,       'DSDRV:'
		csdata	14, parent,      '..'
		csdata	15, root,        '/'
		data	16, crfile
		 ds	32, $00
		endd


;--------------------------------------------------------------------------
end_ptr:
		end
